:li

!!! Listing quadrat1.c

/********************************************************************
 *
 * Beispiel-Programm zu Design-Fallen bei Vererbung
 *
 * Quelle: Bredex GmbH, Braunschweig
 *
 ********************************************************************/

// Standard-Header-Dateien
#include <stdlib.h>
#include <iostream.h>

/* Klasse Rechteck
 */
class Rechteck {
  protected:
    unsigned breite;
    unsigned hoehe;
  public:
    // Konstruktor
    Rechteck (unsigned b, unsigned h) {
	breite = b;
	hoehe = h;
    }

    // Breite oder Hoehe setzen
    virtual void setzeBreite (unsigned b) {
	breite = b;
    }
    virtual void setzeHoehe (unsigned h) {
	hoehe = h;
    }

    // Rechteck ausgeben
    virtual void ausgeben () {
	cout << "Rechteck(" << breite << "x" << hoehe << ")" << endl;
    }
};

/* Klasse Quadrat
 *  - abgeleitet von Rechteck
 *  - keine neuen Komponenten
 */
class Quadrat : public Rechteck {
  public:
    /* Konstruktor
     *  - Groesse g ist Breite und Hoehe vom Rechteck
     */
    Quadrat (unsigned g) : Rechteck(g,g) {
    }

    // Groesse (Breite und Hoehe) setzen
    virtual void setzeGroesse (unsigned g) {
	breite = hoehe = g;
    }
};


main()
{
    Quadrat q(42);

    q.ausgeben();        // "Rechteck(42x42)"

    q.setzeHoehe(17);	 // logischer FEHLER

    q.ausgeben();        // "Rechteck(42x17)"
}


!!! Listing quadrat2.c

/********************************************************************
 *
 * Beispiel-Programm zu geschuetzter Vererbung
 *
 * Quelle: BREDEX GmbH, Braunschweig
 *
 ********************************************************************/

// Standard-Header-Dateien
#include <stdlib.h>
#include <iostream.h>

/* Klasse Rechteck
 */
class Rechteck {
  protected:
    unsigned breite;
    unsigned hoehe;
  public:
    // Konstruktor
    Rechteck (unsigned b, unsigned h) {
	breite = b;
	hoehe = h;
    }

    // Breite oder Hoehe setzen
    virtual void setzeBreite (unsigned b) {
	breite = b;
    }
    virtual void setzeHoehe (unsigned h) {
	hoehe = h;
    }

    // Rechteck ausgeben
    virtual void ausgeben () {
	cout << "Rechteck(" << breite << "x" << hoehe << ")" << endl;
    }
};

/* Klasse Quadrat
 *  - geschuetzt abgeleitet von Rechteck
 *  - keine neuen Komponenten
 */
class Quadrat : protected Rechteck {
  public:
    /* Konstruktor
     *  - Groesse g ist Breite und Hoehe vom Rechteck
     */
    Quadrat (unsigned g) : Rechteck(g,g) {
    }

    // ausgeben() von Rechteck ist weiterhin sinnvoll
    Rechteck::ausgeben;

    // Groesse (Breite und Hoehe) setzen
    virtual void setzeGroesse (unsigned g) {
	breite = hoehe = g;
    }
};


main()
{
    Quadrat q(42);

    q.ausgeben();        // "Rechteck(42x42)"

    q.setzeHoehe(17);    // COMPILER-FEHLER (setzeHoehe() wurde nicht geerbt)

    q.ausgeben();        // "Rechteck(42x17)"
}


!!! Listing 3 "Ausgabe"

quadrat2.c: In function `int  main ()':
quadrat2.c:30: the method `void Rechteck::setzeHoehe (unsigned int)' is protected
quadrat2.c:68: within this context

